// AOcrayon: aocolor.h

#ifndef AOCOLOR_H
#define AOCOLOR_H

#include <qvariant.h>
#include <qvaluelist.h>

class QString;
class QColor;

class AOColor
{
public:
	AOColor(void);
	AOColor( const AOColor& );
	virtual ~AOColor(void) { }

	enum ColorType{ String, Hex3, Hex4 };

	void setName( QString name );
	QString name() const;

	void setColor( QString color );
	void setColor( QColor color );
	void setValue( QString value );
	QString value() const;
	QColor color();

protected:
	QString Name;
	QString Color;
	ColorType Type;
	int r;
	int g;
	int b;
};

inline void AOColor::setName( QString name )
{ Name = name; }

inline QString AOColor::name() const
{ return Name; }

inline void AOColor::setValue( QString value )
{ Color = value; }

inline QString AOColor::value() const
{ return Color; }

class AOColors : public QValueList<AOColor>
{
public:
	AOColors() { }
    AOColors( const AOColors& l ) : QValueList<AOColor>(l) { }
    AOColors( const QValueList<AOColor>& l ) : QValueList<AOColor>(l) { }
    AOColors( const AOColor& i ) { append(i); }
	virtual ~AOColors() { }

	AOColor& getByName( QString name );
};


#endif // AOCOLOR_H